// -------------------------------------------------------------------------------
// 
// 		cwCu		ff[^ǂݍݏRpwb_
// 
// 				Ver 3.22a
// 
// -------------------------------------------------------------------------------

#ifndef DX_MODELLOADER3_H
#define DX_MODELLOADER3_H

#include "DxCompileConfig.h"

#ifndef DX_NON_MODEL

// CN[h ---------------------------------
#include "DxLib.h"
#include "DxStatic.h"
#include "DxModel.h"
#include "DxModelRead.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` -----------------------------------

// f[^^` ---------------------------------

// PMDf[^wb_( 283byte )
struct PMD_HEADER
{
	BYTE	Data[ 283 ] ;						// f[^
/*
	char	Magic[ 3 ] ;						// "Pmd"
	float	Version ;							// 1.0f ( 0x3f800000 )
	char	Name[ 20 ] ;						// O
	char	Comment[ 256 ] ;					// Rg
*/
} ;

// _f[^ӂ̏( 38byte )
struct PMD_VERTEX
{
	float	Position[ 3 ] ;						// W
	float	Normal[ 3 ] ;						// @
	float	Uv[ 2 ] ;							// eNX`W
	WORD	BoneNo[ 2 ] ;						// {[ԍ
	BYTE	BoneWeight ;						// BoneNo[ 0 ] ̃{[̉ex( 0`100 ) BoneNo[ 1 ] ̉ex( 100 - BoneWeight )
	BYTE	Edge ;								// GbWtO  0:GbWL  1:GbW
} ;

// _f[^
struct PMD_VERTEX_DATA
{
	DWORD	Count ;				// _f[^̐
	/*  PMD_VERTEX  Count ݂̐ */
} ;

// ʃXg
struct PMD_FACE_DATA
{
	DWORD	VertexCount ;		// _̐( ʂ̐ VertexCount / 3 )
	/*  WORD ̒_CfbNX VertexCount ݂̐ */
} ;

// }eAӂ̏( 70byte )
struct PMD_MATERIAL
{
	BYTE	Data[ 70 ] ;						// f[^
/*
	float	DiffuseR, DiffuseG, DiffuseB ;		// fBt[YJ[
	float	Alpha ;								// l
	float	Specularity ;						// XyLW
	float	SpecularR, SpecularG, SpecularB ;	// XyLJ[
	float	AmbientR, AmbientG, AmbientB ;		// ArGgJ[
	BYTE	ToolImage ;							// gD[_Op̃eNX`̃CfbNX
	BYTE	Edge ;								// ֊sEe
	DWORD	FaceVertexCount ;					// ̃}eAgpʒ_̐
	char	TextureFileName[ 20 ] ;				// eNX`t@C
*/
} ;

// }eȀ
struct PMD_MATERIAL_DATA
{
	DWORD	Count ;								// }eA̐
	/*  PMD_MATERIAL  Count ݂̐ */
} ;

// {[ӂ̏( 39byte )
struct PMD_BONE
{
	BYTE	Data[ 39 ] ;						// f[^
/*
	char	Name[ 20 ] ;						//  0:{[
	WORD	Parent ;							// 20:e{[( ꍇ 0xffff )
	WORD	TailPosBone ;						// 22:Tail ʒũ{[( `F[[̏ꍇ 0xffff )
	BYTE	Type ;								// 24:{[̃^Cv( 0:]  1:]ƈړ  2:IK  3:s  4:IKe  5:]e  6:IKڑ  7:\  8:P  9:]^ )
	WORD	IkParent ;							// 25:IK{[ԍ( eIK{[  ꍇ 0xffff )
	float	HeadPos[ 3 ] ;						// 27:wbḧʒu
*/
} ;

// {[̏
struct PMD_BONE_DATA
{
	WORD	Count ;								// {[̐
	/*  PMD_BONE  Count ݂̐ */
} ;

// IKf[^ӂ̏( ChainBoneIndex 𔲂TCY 11byte )
struct PMD_IK
{
	BYTE	Data[ 11 ] ;						// f[^
/*
	WORD	Bone ;								// IK{[
	WORD	TargetBone ;						// IK^[Qbg{[
	BYTE	ChainLength ;						// IK`F[̒(q̐)
	WORD	Iterations ;						// ċNZ
	float	ControlWeight ;						// IK̉ex
	WORD	ChainBoneIndexs[ ChainLength ] ;	// IKẽ{[ԍ
*/
} ;

// IK̏
struct PMD_IK_DATA
{
	WORD	Count ;								// IKf[^̐
	/*  PMD_IK  Count ݂̐ */
} ;

// \̒_
struct PMD_SKIN_VERT
{
	DWORD	TargetVertexIndex ;					// Ώۂ̒_̃CfbNX
	float	Position[ 3 ] ;						// W( PMD_SKIN  SkinType  0 Ȃ΍WAȊOȂ base ɑ΂鑊΍W )
} ;

// \ӂ̏( Vertex 𔲂TCY 25byte )
struct PMD_SKIN
{
	BYTE	Data[ 25 ] ;						// f[^
/*
	char	Name[ 20 ] ;						// \
	DWORD	VertexCount ;						// _̐
	BYTE	SkinType ;							// \̎( 0:base 1F܂A2FځA3FbvA4F̑ )
	PMD_SKIN_VERT Vertex[ VertexCount ] ;		// \p̒_f[^
*/
} ;

// \̏
struct PMD_SKIN_DATA
{
	WORD	Count ;								// \f[^̐
	/*  PMD_SKIN  Count ݂̐ */
} ;

// Zf[^ӂ̏( 83byte )
struct PMD_PHYSICS
{
	BYTE	Data[ 83 ] ;	
/*
	char	RigidBodyName[ 20 ] ;				//  0 : ̖
	WORD	RigidBodyRelBoneIndex ;				// 20 : ̊֘A{[ԍ
	BYTE	RigidBodyGroupIndex ;				// 22 : ̃O[vԍ
	WORD	RigidBodyGroupTarget ;				// 23 : ̃O[vΏ
	BYTE	ShapeType ;							// 25 : `( 0:  1:  2:JvZ )
	float	ShapeW ;							// 26 : 
	float	ShapeH ;							// 30 : 
	float	ShapeD ;							// 34 : s
	float	Position[ 3 ] ;						// 38 : ʒu
	float	Rotation[ 3 ] ;						// 50 : ]( WA )
	float	RigidBodyWeight ;					// 62 : 
	float	RigidBodyPosDim ;					// 66 : ړ
	float	RigidBodyRotDim ;					// 70 : ]
	float	RigidBodyRecoil ;					// 74 : 
	float	RigidBodyFriction ;					// 78 : C
	BYTE	RigidBodyType ;						// 82 : ̃^Cv( 0:BoneǏ]  1:Z  2:Z(Boneʒu킹) )
*/
} ;

// Zf[^̏
struct PMD_PHYSICS_DATA
{
	DWORD	Count ;								// ̃f[^̐
	/*  PMD_PHYSICS  Count ݂̐ */
} ;

// ZpWCgf[^ӂ̏( 124byte )
struct PMD_PHYSICS_JOINT
{
	char	Name[ 20 ] ;						// O
	DWORD	RigidBodyA ;						// ڑ捄̂`
	DWORD	RigidBodyB ;						// ڑ捄̂a
	float	Position[ 3 ] ;						// ʒu
	float	Rotation[ 3 ] ;						// ]( WA )
	float	ConstrainPosition1[ 3 ] ;			// ړlP
	float	ConstrainPosition2[ 3 ] ;			// ړlQ
	float	ConstrainRotation1[ 3 ] ;			// ]lP
	float	ConstrainRotation2[ 3 ] ;			// ]lQ
	float	SpringPosition[ 3 ] ;				// ΂ˈړl
	float	SpringRotation[ 3 ] ;				// ΂ˉ]l
} ;

// ZpWCg
struct PMD_PHYSICS_JOINT_DATA
{
	DWORD	Count ;								// WCgf[^̐
	/*  PMD_PHYSICS_JOINT  Count ݂̐ */
} ;

// VMDǂݍݏpPMD{[f[^
struct PMD_READ_BONE_INFO
{
	PMD_BONE			*Base ;					// {[f[^
	MV1_ANIM_R			*Anim ;					// ̃{[p̃Aj[Vւ̃|C^
	MV1_FRAME_R			*Frame ;				// ̃{[p̃t[ւ̃|C^

	VECTOR				*KeyPos ;				// WAj[VL[z̐擪
	FLOAT4				*KeyRot ;				// ]Aj[VL[z̐擪
	float				*KeyDisablePhysics ;	// ZL[z̐擪
	float				*KeyPosTime ;			// WAj[V^CL[z̐擪
	float				*KeyRotTime ;			// ]Aj[V^CL[z̐擪
	MATRIX				*KeyMatrix ;			// sAj[VL[z̐擪
	MATRIX				*KeyMatrix2 ;			// sAj[VL[z̐擪( IsIKChild  TRUE ̃{[p )

	int					Type ;					// ^Cv
	int					IsPhysics ;				// gpĂ邩ǂ
	int					IsIK ;					// hj{[ǂ
	int					IsIKAnim ;				// hjAj[V邩ǂ
	int					IsIKChild ;				// hjAj[V{[̎q{[( hj̉e󂯂Ȃ{[ )ǂ
	int					IKLimitAngle ;			// hjɊpx邩ǂ
	MATRIX				LocalMatrix ;			// \z[Js
	int					SetupLocalWorldMatrix ;	// [J[hs񂪍\zĂ邩ǂ
	MATRIX				LocalWorldMatrix ;		// \z[J[hs
	int					BackupLocalWorldMatrix_Valid ;	// BackupLocalWorldMatrix Lǂ
	MATRIX				BackupLocalWorldMatrix ;		// \z[J[hs( Z̃obNAbvp )
	VECTOR				Translate ;				// sړl
	FLOAT4				Rotate ;				// ]l
	float				DisablePhysics ;		// Z
	VECTOR				TimeDivLoopCount0_Translate ;			// TimeDivLoopCount == 0 ̕sړl
	FLOAT4				TimeDivLoopCount0_Rotate ;				// TimeDivLoopCount == 0 ̉]l
	MATRIX				TimeDivLoopCount0_LocalWorldMatrix ;	// TimeDivLoopCount == 0 ̍\z[J[hs
	VECTOR				OrgTranslate ;			// _̏ʒu

	MATRIX				IKmat ;					// IKŎgps\
	FLOAT4				IKQuat ;				// IKŎgpNH[^jI

	VECTOR				InitTranslate ;			// sړl̏l
	FLOAT4				InitRotate ;			// ]l̏l
#ifndef DX_NON_BULLET_PHYSICS
	int					PhysicsIndex ;			// Zp̔ԍ
	int					SetupPhysicsAnim ;		// {[Aj[Vtǂ
#endif

	struct VMD_READ_NODE_INFO	*Node ;			// {[Ɗ֘AtĂm[h
	struct VMD_READ_KEY_INFO	*NowKey ;		// ݍĐĂL[
} ;

// VMDǂݍݏpPMDIK{[f[^
struct PMD_READ_IK_INFO
{
	PMD_IK				*Base ;					// IK{[f[^
	PMD_READ_BONE_INFO	*Bone ;					// IK^[Qbg{[
	PMD_READ_BONE_INFO	*TargetBone ;			// IK[{[

	WORD				LimitAngleIK ;			// px{[܂܂ꂽhjǂ( 0:Ⴄ 1: ) 
	WORD				Iterations ;			// ċNZ
	float				ControlWeight ;			// IK̉ex
	float				IKTotalLength ;			// IK̍`FC̍Ō܂ł̋

	int					ChainBoneNum ;			// IK`F[̒(q̐)
	WORD				*ChainBone ;			// IKẽ{[ւ̃CfbNXzւ̃|C^

	PMD_READ_IK_INFO	*Prev ;					// Xg̑Õf[^ւ̃AhX
	PMD_READ_IK_INFO	*Next ;					// Xg̎̃f[^ւ̃AhX
} ;

// PMDǂݍݏpZpf[^
struct PMD_READ_PHYSICS_INFO
{
	PMD_PHYSICS			*Base ;					// f[^

	char				Name[ 24 ] ;			// O
	WORD				BoneIndex ;				// Ώۂ̃{[

	PMD_READ_BONE_INFO	*Bone ;					// {[̏ւ̃|C^
	int					ShapeType ;				// `^Cv( 0:  1:  2:JvZ )
	int					RigidBodyType ;			// ̃^Cv( 0:BoneǏ]  1:Z  2:Z(Boneʒu킹) )
	bool				NoCopyToBone ;			// {[֍̂̏Ԃ킷sRs[Ȃǂ

	DWORD				BulletInfo[ 160 ] ;		// BULLET_RIGIDBODY_INFO i[obt@
} ;

// PMDǂݍݏpPMDZpWCgf[^
struct PMD_READ_PHYSICS_JOINT_INFO
{
	PMD_PHYSICS_JOINT	Base ;					// WCgf[^

	DWORD				BulletInfo[ 16 ] ;		// BULLET_JOINT_INFO i[obt@
} ;


// olcǂݍݏ̕֌W̏Z߂\
struct DX_MODELLOADER3_PMD_PHYSICS_INFO
{
	VECTOR Gravity ;
	int MotionTotalFrameNum ;

	int LoopMotionFlag ;
	int LoopMotionNum ;

	int	PhysicsCalcPrecision ;

	int PmdPhysicsNum ;
	PMD_READ_PHYSICS_INFO *PmdPhysicsInfoDim ;

	int PmdPhysicsJointNum ;
	PMD_READ_PHYSICS_JOINT_INFO *PmdPhysicsJointInfoDim ;

	MV1_ANIMKEYSET_R *KeyMatrixSet ;

	DWORD BulletPhysicsDataBuffer[ 32 ] ;			// BULLET_PHYSICS i[obt@
} ;


// ֐錾 -------------------------------------

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#ifndef DX_NON_BULLET_PHYSICS

extern int SetupPhysicsObject_PMDPhysicsInfo(		DX_MODELLOADER3_PMD_PHYSICS_INFO *MLPhysicsInfo, int DisablePhysicsFile ) ;
extern int ReleasePhysicsObject_PMDPhysicsInfo(		DX_MODELLOADER3_PMD_PHYSICS_INFO *MLPhysicsInfo ) ;
extern int OneFrameProcess_PMDPhysicsInfo(			DX_MODELLOADER3_PMD_PHYSICS_INFO *MLPhysicsInfo, int FrameNo, int LoopNo, bool FPS60, int ValidNextRate, int TimeDivNum ) ;
extern int CheckDisablePhysicsAnim_PMDPhysicsInfo(	DX_MODELLOADER3_PMD_PHYSICS_INFO *MLPhysicsInfo, int PhysicsIndex ) ;

extern int SetupPhysicsObject_ModelPhysicsInfo(		MV1_MODEL *Model ) ;
extern int ReleasePhysicsObject_ModelPhysicsInfo(	MV1_MODEL *Model ) ;
extern int ResetState_ModelPhysicsInfo(				MV1_MODEL *Model ) ;
extern int StepSimulation_ModelPhysicsInfo(			MV1_MODEL *Model, float TimeStep ) ;
extern int SetWorldGravity_ModelPhysiceInfo(		MV1_MODEL *Model, VECTOR Gravity ) ;

#endif

#endif
#endif
