//-----------------------------------------------------------------------------
// 
// 		cwCu		Live2D Cubism4֌WvO( Windows )
// 
//  	Ver 3.22a
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define DX_MAKE

#include "../DxCompileConfig.h"

#ifndef DX_NON_LIVE2D_CUBISM4

// CN[h----------------------------------------------------------------
#include "../DxLib.h"
#include "../DxStatic.h"
#include "../DxLive2DCubism4.h"
#include "../DxGraphics.h"
#include "../DxMemory.h"
#include "../DxArchive_.h"
#include "../DxLog.h"
#include "DxGraphicsWin.h"

// #ifndef DX_NON_NAMESPACE
// 
// namespace DxLib
// {
// 
// #endif // DX_NON_NAMESPACE

// }N`------------------------------------------------------------------

// ^`----------------------------------------------------------------------

// f[^錾------------------------------------------------------------------

#ifndef DX_NON_DIRECT3D11
extern int  DxShaderCodeBin_Live2D_Cubism4_D3D11Convert ;
extern BYTE DxShaderCodeBin_Live2D_Cubism4_D3D11[] ;
#endif // DX_NON_DIRECT3D11

extern int  DxShaderCodeBin_Live2D_Cubism4_D3D9Convert ;
extern BYTE DxShaderCodeBin_Live2D_Cubism4_D3D9[] ;

// ֐vg^Cv錾 -------------------------------------------------------

// DLL ̓ǂݍ݁E
static	int			Live2DCubism4_DLL_Load( void ) ;														// Live2D Cubism 4 DLL ̓ǂݍ
static	int			Live2DCubism4_DLL_Unload( void ) ;														// Live2D Cubism 4 DLL ̉

// vO------------------------------------------------------------------

// DLL ̓ǂݍ݁E

// Live2D Cubism 4 DLL ̓ǂݍ
static int Live2DCubism4_DLL_Load( void )
{
	if( LIVE2DSYS.PF.Live2DCubismCoreDLL == NULL )
	{
		if( LIVE2DDLL.Live2DCubismCoreDLLPath[ 0 ] != '\0' )
		{
			LIVE2DSYS.PF.Live2DCubismCoreDLL = LoadLibraryW( LIVE2DDLL.Live2DCubismCoreDLLPath ) ;
		}
		else
		{
			LIVE2DSYS.PF.Live2DCubismCoreDLL = LoadLibraryW( L"Live2DCubismCore.dll" ) ;
		}
		if( LIVE2DSYS.PF.Live2DCubismCoreDLL == NULL )
		{
			if( LIVE2DDLL.Live2DCubismCoreDLLPath[ 0 ] != '\0' )
			{
				DXST_LOGFILE_ADDUTF16LE( "\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x43\x00\x75\x00\x62\x00\x69\x00\x73\x00\x6d\x00\x43\x00\x6f\x00\x72\x00\x65\x00\x2e\x00\x64\x00\x6c\x00\x6c\x00\x20\x00\x6e\x30\xad\x8a\x7f\x30\xbc\x8f\x7f\x30\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Live2DCubismCore.dll ̓ǂݍ݂Ɏs܂\n" @*/ ) ;
			}
			return -1 ;
		}

		DXST_LOGFILE_ADDUTF16LE( "\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x43\x00\x75\x00\x62\x00\x69\x00\x73\x00\x6d\x00\x43\x00\x6f\x00\x72\x00\x65\x00\x2e\x00\x64\x00\x6c\x00\x6c\x00\x20\x00\x6e\x30\xad\x8a\x7f\x30\xbc\x8f\x7f\x30\x6b\x30\x10\x62\x9f\x52\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Live2DCubismCore.dll ̓ǂݍ݂ɐ܂\n" @*/ ) ;

#ifdef _WIN64
		LIVE2DDLL.csmGetVersion						= ( DWORD					( * )( void ) )																												GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetVersion"					) ;
		LIVE2DDLL.csmGetLatestMocVersion			= ( DWORD					( * )( void ) )																												GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetLatestMocVersion"			) ;
		LIVE2DDLL.csmGetMocVersion					= ( DWORD					( * )( const void* address, const DWORD size ) )																			GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetMocVersion"				) ;
		LIVE2DDLL.csmGetLogFunction					= ( csmLogFunctionP			( * )( void ) )																												GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetLogFunction"				) ;
		LIVE2DDLL.csmSetLogFunction					= ( void					( * )( csmLogFunctionP handler ) )																							GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmSetLogFunction"				) ;
		LIVE2DDLL.csmReviveMocInPlace				= ( void*					( * )( void* address, const DWORD size ) )																					GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmReviveMocInPlace"				) ;
		LIVE2DDLL.csmGetSizeofModel					= ( DWORD 					( * )( const void* moc ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetSizeofModel"				) ;
		LIVE2DDLL.csmInitializeModelInPlace			= ( void* 					( * )( const void* moc, void* address, const DWORD size ) )																	GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmInitializeModelInPlace"		) ;
		LIVE2DDLL.csmUpdateModel					= ( void 					( * )( void* model ) )																										GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmUpdateModel"					) ;
		LIVE2DDLL.csmReadCanvasInfo					= ( void 					( * )( const void* model, D_CubismVector2* outSizeInPixels, D_CubismVector2* outOriginInPixels, float* outPixelsPerUnit ) )	GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmReadCanvasInfo"				) ;
		LIVE2DDLL.csmGetParameterCount				= ( int 					( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterCount"			) ;
		LIVE2DDLL.csmGetParameterIds 				= ( const char** 			( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterIds"				) ;
		LIVE2DDLL.csmGetParameterMinimumValues		= ( const float*			( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterMinimumValues"	) ;
		LIVE2DDLL.csmGetParameterMaximumValues		= ( const float*			( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterMaximumValues"	) ;
		LIVE2DDLL.csmGetParameterDefaultValues		= ( const float*			( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterDefaultValues"	) ;
		LIVE2DDLL.csmGetParameterValues				= ( float* 					( * )( void* model ) )																										GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterValues"			) ;
		LIVE2DDLL.csmGetPartCount					= ( int 					( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetPartCount"					) ;
		LIVE2DDLL.csmGetPartIds						= ( const char**			( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetPartIds"					) ;
		LIVE2DDLL.csmGetPartOpacities				= ( float*					( * )( void* model ) )																										GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetPartOpacities"				) ;
		LIVE2DDLL.csmGetPartParentPartIndices 		= ( const int*				( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetPartParentPartIndices"		) ;
		LIVE2DDLL.csmGetDrawableCount				= ( int 					( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableCount"				) ;
		LIVE2DDLL.csmGetDrawableIds					= ( const char**			( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableIds"				) ;
		LIVE2DDLL.csmGetDrawableConstantFlags 		= ( const BYTE*				( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableConstantFlags"		) ;
		LIVE2DDLL.csmGetDrawableDynamicFlags		= ( const BYTE*				( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableDynamicFlags"		) ;
		LIVE2DDLL.csmGetDrawableTextureIndices		= ( const int*				( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableTextureIndices"	) ;
		LIVE2DDLL.csmGetDrawableDrawOrders			= ( const int*				( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableDrawOrders"		) ;
		LIVE2DDLL.csmGetDrawableRenderOrders		= ( const int*				( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableRenderOrders"		) ;
		LIVE2DDLL.csmGetDrawableOpacities			= ( const float*			( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableOpacities"			) ;
		LIVE2DDLL.csmGetDrawableMaskCounts 			= ( const int*				( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableMaskCounts"		) ;
		LIVE2DDLL.csmGetDrawableMasks				= ( const int**				( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableMasks"				) ;
		LIVE2DDLL.csmGetDrawableVertexCounts		= ( const int*				( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableVertexCounts"		) ;
		LIVE2DDLL.csmGetDrawableVertexPositions		= ( const D_CubismVector2**	( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableVertexPositions"	) ;
		LIVE2DDLL.csmGetDrawableVertexUvs			= ( const D_CubismVector2**	( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableVertexUvs"			) ;
		LIVE2DDLL.csmGetDrawableIndexCounts			= ( const int*				( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableIndexCounts"		) ;
		LIVE2DDLL.csmGetDrawableIndices 			= ( const unsigned short**	( * )( const void* model ) )																								GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableIndices"			) ;
		LIVE2DDLL.csmResetDrawableDynamicFlags		= ( void					( * )( void* model ) )																										GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmResetDrawableDynamicFlags"	) ;

		if( LIVE2DDLL.csmGetVersion == NULL )
		{
			LIVE2DDLL.std_csmGetVersion						= ( DWORD					( __stdcall * )( void ) )																												GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetVersion@0"					) ;
			LIVE2DDLL.std_csmGetLatestMocVersion			= ( DWORD					( __stdcall * )( void ) )																												GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetLatestMocVersion@0"			) ;
			LIVE2DDLL.std_csmGetMocVersion					= ( DWORD					( __stdcall * )( const void* address, const DWORD size ) )																				GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetMocVersion@8"					) ;
			LIVE2DDLL.std_csmGetLogFunction					= ( csmLogFunctionP			( __stdcall * )( void ) )																												GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetLogFunction@0"				) ;
			LIVE2DDLL.std_csmSetLogFunction					= ( void					( __stdcall * )( csmLogFunctionP handler ) )																							GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmSetLogFunction@4"				) ;
			LIVE2DDLL.std_csmReviveMocInPlace				= ( void*					( __stdcall * )( void* address, const DWORD size ) )																					GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmReviveMocInPlace@8"				) ;
			LIVE2DDLL.std_csmGetSizeofModel					= ( DWORD 					( __stdcall * )( const void* moc ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetSizeofModel@4"				) ;
			LIVE2DDLL.std_csmInitializeModelInPlace			= ( void* 					( __stdcall * )( const void* moc, void* address, const DWORD size ) )																	GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmInitializeModelInPlace@12"		) ;
			LIVE2DDLL.std_csmUpdateModel					= ( void 					( __stdcall * )( void* model ) )																										GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmUpdateModel@4"					) ;
			LIVE2DDLL.std_csmReadCanvasInfo					= ( void 					( __stdcall * )( const void* model, D_CubismVector2* outSizeInPixels, D_CubismVector2* outOriginInPixels, float* outPixelsPerUnit ) )	GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmReadCanvasInfo@16"				) ;
			LIVE2DDLL.std_csmGetParameterCount				= ( int 					( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetParameterCount@4"				) ;
			LIVE2DDLL.std_csmGetParameterIds 				= ( const char** 			( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetParameterIds@4"				) ;
			LIVE2DDLL.std_csmGetParameterMinimumValues		= ( const float*			( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetParameterMinimumValues@4"		) ;
			LIVE2DDLL.std_csmGetParameterMaximumValues		= ( const float*			( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetParameterMaximumValues@4"		) ;
			LIVE2DDLL.std_csmGetParameterDefaultValues		= ( const float*			( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetParameterDefaultValues@4"		) ;
			LIVE2DDLL.std_csmGetParameterValues				= ( float* 					( __stdcall * )( void* model ) )																										GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetParameterValues@4"			) ;
			LIVE2DDLL.std_csmGetPartCount					= ( int 					( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetPartCount@4"					) ;
			LIVE2DDLL.std_csmGetPartIds						= ( const char**			( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetPartIds@4"					) ;
			LIVE2DDLL.std_csmGetPartOpacities				= ( float*					( __stdcall * )( void* model ) )																										GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetPartOpacities@4"				) ;
			LIVE2DDLL.std_csmGetPartParentPartIndices 		= ( const int*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetPartParentPartIndices@4"		) ;
			LIVE2DDLL.std_csmGetDrawableCount				= ( int 					( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetDrawableCount@4"				) ;
			LIVE2DDLL.std_csmGetDrawableIds					= ( const char**			( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetDrawableIds@4"				) ;
			LIVE2DDLL.std_csmGetDrawableConstantFlags 		= ( const BYTE*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetDrawableConstantFlags@4"		) ;
			LIVE2DDLL.std_csmGetDrawableDynamicFlags		= ( const BYTE*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetDrawableDynamicFlags@4"		) ;
			LIVE2DDLL.std_csmGetDrawableTextureIndices		= ( const int*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetDrawableTextureIndices@4"		) ;
			LIVE2DDLL.std_csmGetDrawableDrawOrders			= ( const int*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetDrawableDrawOrders@4"			) ;
			LIVE2DDLL.std_csmGetDrawableRenderOrders		= ( const int*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetDrawableRenderOrders@4"		) ;
			LIVE2DDLL.std_csmGetDrawableOpacities			= ( const float*			( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetDrawableOpacities@4"			) ;
			LIVE2DDLL.std_csmGetDrawableMaskCounts 			= ( const int*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetDrawableMaskCounts@4"			) ;
			LIVE2DDLL.std_csmGetDrawableMasks				= ( const int**				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetDrawableMasks@4"				) ;
			LIVE2DDLL.std_csmGetDrawableVertexCounts		= ( const int*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetDrawableVertexCounts@4"		) ;
			LIVE2DDLL.std_csmGetDrawableVertexPositions		= ( const D_CubismVector2**	( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetDrawableVertexPositions@4"	) ;
			LIVE2DDLL.std_csmGetDrawableVertexUvs			= ( const D_CubismVector2**	( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetDrawableVertexUvs@4"			) ;
			LIVE2DDLL.std_csmGetDrawableIndexCounts			= ( const int*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetDrawableIndexCounts@4"		) ;
			LIVE2DDLL.std_csmGetDrawableIndices 			= ( const unsigned short**	( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmGetDrawableIndices@4"			) ;
			LIVE2DDLL.std_csmResetDrawableDynamicFlags		= ( void					( __stdcall * )( void* model ) )																										GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "_csmResetDrawableDynamicFlags@4"		) ;

			if( LIVE2DDLL.std_csmGetVersion						== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x56\x00\x65\x00\x72\x00\x73\x00\x69\x00\x6f\x00\x6e\x00\x40\x00\x30\x00\x09\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetVersion@0					擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetLatestMocVersion			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x4c\x00\x61\x00\x74\x00\x65\x00\x73\x00\x74\x00\x4d\x00\x6f\x00\x63\x00\x56\x00\x65\x00\x72\x00\x73\x00\x69\x00\x6f\x00\x6e\x00\x40\x00\x30\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetLatestMocVersion@0			擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetMocVersion					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x4d\x00\x6f\x00\x63\x00\x56\x00\x65\x00\x72\x00\x73\x00\x69\x00\x6f\x00\x6e\x00\x40\x00\x38\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetMocVersion@8				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetLogFunction					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x4c\x00\x6f\x00\x67\x00\x46\x00\x75\x00\x6e\x00\x63\x00\x74\x00\x69\x00\x6f\x00\x6e\x00\x40\x00\x30\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetLogFunction@0				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmSetLogFunction					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x53\x00\x65\x00\x74\x00\x4c\x00\x6f\x00\x67\x00\x46\x00\x75\x00\x6e\x00\x63\x00\x74\x00\x69\x00\x6f\x00\x6e\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmSetLogFunction@4				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmReviveMocInPlace				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x52\x00\x65\x00\x76\x00\x69\x00\x76\x00\x65\x00\x4d\x00\x6f\x00\x63\x00\x49\x00\x6e\x00\x50\x00\x6c\x00\x61\x00\x63\x00\x65\x00\x40\x00\x38\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmReviveMocInPlace@8				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetSizeofModel					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x6f\x00\x66\x00\x4d\x00\x6f\x00\x64\x00\x65\x00\x6c\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetSizeofModel@4				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmInitializeModelInPlace			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x49\x00\x6e\x00\x69\x00\x74\x00\x69\x00\x61\x00\x6c\x00\x69\x00\x7a\x00\x65\x00\x4d\x00\x6f\x00\x64\x00\x65\x00\x6c\x00\x49\x00\x6e\x00\x50\x00\x6c\x00\x61\x00\x63\x00\x65\x00\x40\x00\x31\x00\x32\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmInitializeModelInPlace@12		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmUpdateModel					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x55\x00\x70\x00\x64\x00\x61\x00\x74\x00\x65\x00\x4d\x00\x6f\x00\x64\x00\x65\x00\x6c\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmUpdateModel@4					擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmReadCanvasInfo					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x52\x00\x65\x00\x61\x00\x64\x00\x43\x00\x61\x00\x6e\x00\x76\x00\x61\x00\x73\x00\x49\x00\x6e\x00\x66\x00\x6f\x00\x40\x00\x31\x00\x36\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmReadCanvasInfo@16				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetParameterCount				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetParameterCount@4			擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetParameterIds 				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x49\x00\x64\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetParameterIds@4				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetParameterMinimumValues		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x4d\x00\x69\x00\x6e\x00\x69\x00\x6d\x00\x75\x00\x6d\x00\x56\x00\x61\x00\x6c\x00\x75\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetParameterMinimumValues@4	擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetParameterMaximumValues		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x4d\x00\x61\x00\x78\x00\x69\x00\x6d\x00\x75\x00\x6d\x00\x56\x00\x61\x00\x6c\x00\x75\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetParameterMaximumValues@4	擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetParameterDefaultValues		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x44\x00\x65\x00\x66\x00\x61\x00\x75\x00\x6c\x00\x74\x00\x56\x00\x61\x00\x6c\x00\x75\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetParameterDefaultValues@4	擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetParameterValues				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x56\x00\x61\x00\x6c\x00\x75\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetParameterValues@4			擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetPartCount					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x74\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetPartCount@4					擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetPartIds						== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x74\x00\x49\x00\x64\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetPartIds@4					擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetPartOpacities				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x74\x00\x4f\x00\x70\x00\x61\x00\x63\x00\x69\x00\x74\x00\x69\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetPartOpacities@4				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetPartParentPartIndices 		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x74\x00\x50\x00\x61\x00\x72\x00\x65\x00\x6e\x00\x74\x00\x50\x00\x61\x00\x72\x00\x74\x00\x49\x00\x6e\x00\x64\x00\x69\x00\x63\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetPartParentPartIndices@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetDrawableCount				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableCount@4				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetDrawableIds					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x49\x00\x64\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableIds@4				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetDrawableConstantFlags 		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x43\x00\x6f\x00\x6e\x00\x73\x00\x74\x00\x61\x00\x6e\x00\x74\x00\x46\x00\x6c\x00\x61\x00\x67\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableConstantFlags@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetDrawableDynamicFlags		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x44\x00\x79\x00\x6e\x00\x61\x00\x6d\x00\x69\x00\x63\x00\x46\x00\x6c\x00\x61\x00\x67\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableDynamicFlags@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetDrawableTextureIndices		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x54\x00\x65\x00\x78\x00\x74\x00\x75\x00\x72\x00\x65\x00\x49\x00\x6e\x00\x64\x00\x69\x00\x63\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableTextureIndices@4	擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetDrawableDrawOrders			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x44\x00\x72\x00\x61\x00\x77\x00\x4f\x00\x72\x00\x64\x00\x65\x00\x72\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableDrawOrders@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetDrawableRenderOrders		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x52\x00\x65\x00\x6e\x00\x64\x00\x65\x00\x72\x00\x4f\x00\x72\x00\x64\x00\x65\x00\x72\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableRenderOrders@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetDrawableOpacities			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x4f\x00\x70\x00\x61\x00\x63\x00\x69\x00\x74\x00\x69\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableOpacities@4			擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetDrawableMaskCounts 			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x4d\x00\x61\x00\x73\x00\x6b\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableMaskCounts@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetDrawableMasks				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x4d\x00\x61\x00\x73\x00\x6b\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableMasks@4				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetDrawableVertexCounts		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x56\x00\x65\x00\x72\x00\x74\x00\x65\x00\x78\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableVertexCounts@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetDrawableVertexPositions		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x56\x00\x65\x00\x72\x00\x74\x00\x65\x00\x78\x00\x50\x00\x6f\x00\x73\x00\x69\x00\x74\x00\x69\x00\x6f\x00\x6e\x00\x73\x00\x40\x00\x34\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableVertexPositions@4	擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetDrawableVertexUvs			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x56\x00\x65\x00\x72\x00\x74\x00\x65\x00\x78\x00\x55\x00\x76\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableVertexUvs@4			擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetDrawableIndexCounts			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x49\x00\x6e\x00\x64\x00\x65\x00\x78\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableIndexCounts@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmGetDrawableIndices 			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x49\x00\x6e\x00\x64\x00\x69\x00\x63\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableIndices@4			擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.std_csmResetDrawableDynamicFlags		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x52\x00\x65\x00\x73\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x44\x00\x79\x00\x6e\x00\x61\x00\x6d\x00\x69\x00\x63\x00\x46\x00\x6c\x00\x61\x00\x67\x00\x73\x00\x40\x00\x34\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmResetDrawableDynamicFlags@4	擾ł܂ł\n" @*/ ) ; return -1 ; }
		}
		else
		{
			if( LIVE2DDLL.csmGetVersion						== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x56\x00\x65\x00\x72\x00\x73\x00\x69\x00\x6f\x00\x6e\x00\x09\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetVersion					擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetLatestMocVersion			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x4c\x00\x61\x00\x74\x00\x65\x00\x73\x00\x74\x00\x4d\x00\x6f\x00\x63\x00\x56\x00\x65\x00\x72\x00\x73\x00\x69\x00\x6f\x00\x6e\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetLatestMocVersion			擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetMocVersion					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x4d\x00\x6f\x00\x63\x00\x56\x00\x65\x00\x72\x00\x73\x00\x69\x00\x6f\x00\x6e\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetMocVersion				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetLogFunction					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x4c\x00\x6f\x00\x67\x00\x46\x00\x75\x00\x6e\x00\x63\x00\x74\x00\x69\x00\x6f\x00\x6e\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetLogFunction				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmSetLogFunction					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x53\x00\x65\x00\x74\x00\x4c\x00\x6f\x00\x67\x00\x46\x00\x75\x00\x6e\x00\x63\x00\x74\x00\x69\x00\x6f\x00\x6e\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmSetLogFunction				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmReviveMocInPlace				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x52\x00\x65\x00\x76\x00\x69\x00\x76\x00\x65\x00\x4d\x00\x6f\x00\x63\x00\x49\x00\x6e\x00\x50\x00\x6c\x00\x61\x00\x63\x00\x65\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmReviveMocInPlace			擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetSizeofModel					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x6f\x00\x66\x00\x4d\x00\x6f\x00\x64\x00\x65\x00\x6c\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetSizeofModel				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmInitializeModelInPlace			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x49\x00\x6e\x00\x69\x00\x74\x00\x69\x00\x61\x00\x6c\x00\x69\x00\x7a\x00\x65\x00\x4d\x00\x6f\x00\x64\x00\x65\x00\x6c\x00\x49\x00\x6e\x00\x50\x00\x6c\x00\x61\x00\x63\x00\x65\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmInitializeModelInPlace		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmUpdateModel					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x55\x00\x70\x00\x64\x00\x61\x00\x74\x00\x65\x00\x4d\x00\x6f\x00\x64\x00\x65\x00\x6c\x00\x09\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmUpdateModel					擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmReadCanvasInfo					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x52\x00\x65\x00\x61\x00\x64\x00\x43\x00\x61\x00\x6e\x00\x76\x00\x61\x00\x73\x00\x49\x00\x6e\x00\x66\x00\x6f\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmReadCanvasInfo				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetParameterCount				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetParameterCount			擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetParameterIds 				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x49\x00\x64\x00\x73\x00\x20\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetParameterIds 			擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetParameterMinimumValues		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x4d\x00\x69\x00\x6e\x00\x69\x00\x6d\x00\x75\x00\x6d\x00\x56\x00\x61\x00\x6c\x00\x75\x00\x65\x00\x73\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetParameterMinimumValues	擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetParameterMaximumValues		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x4d\x00\x61\x00\x78\x00\x69\x00\x6d\x00\x75\x00\x6d\x00\x56\x00\x61\x00\x6c\x00\x75\x00\x65\x00\x73\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetParameterMaximumValues	擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetParameterDefaultValues		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x44\x00\x65\x00\x66\x00\x61\x00\x75\x00\x6c\x00\x74\x00\x56\x00\x61\x00\x6c\x00\x75\x00\x65\x00\x73\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetParameterDefaultValues	擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetParameterValues				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x56\x00\x61\x00\x6c\x00\x75\x00\x65\x00\x73\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetParameterValues			擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetPartCount					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x74\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetPartCount				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetPartIds						== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x74\x00\x49\x00\x64\x00\x73\x00\x09\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetPartIds					擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetPartOpacities				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x74\x00\x4f\x00\x70\x00\x61\x00\x63\x00\x69\x00\x74\x00\x69\x00\x65\x00\x73\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetPartOpacities			擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetPartParentPartIndices 		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x74\x00\x50\x00\x61\x00\x72\x00\x65\x00\x6e\x00\x74\x00\x50\x00\x61\x00\x72\x00\x74\x00\x49\x00\x6e\x00\x64\x00\x69\x00\x63\x00\x65\x00\x73\x00\x20\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetPartParentPartIndices 	擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetDrawableCount				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetDrawableCount			擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetDrawableIds					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x49\x00\x64\x00\x73\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetDrawableIds				擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetDrawableConstantFlags 		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x43\x00\x6f\x00\x6e\x00\x73\x00\x74\x00\x61\x00\x6e\x00\x74\x00\x46\x00\x6c\x00\x61\x00\x67\x00\x73\x00\x20\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetDrawableConstantFlags 	擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetDrawableDynamicFlags		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x44\x00\x79\x00\x6e\x00\x61\x00\x6d\x00\x69\x00\x63\x00\x46\x00\x6c\x00\x61\x00\x67\x00\x73\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetDrawableDynamicFlags		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetDrawableTextureIndices		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x54\x00\x65\x00\x78\x00\x74\x00\x75\x00\x72\x00\x65\x00\x49\x00\x6e\x00\x64\x00\x69\x00\x63\x00\x65\x00\x73\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetDrawableTextureIndices	擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetDrawableDrawOrders			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x44\x00\x72\x00\x61\x00\x77\x00\x4f\x00\x72\x00\x64\x00\x65\x00\x72\x00\x73\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetDrawableDrawOrders		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetDrawableRenderOrders		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x52\x00\x65\x00\x6e\x00\x64\x00\x65\x00\x72\x00\x4f\x00\x72\x00\x64\x00\x65\x00\x72\x00\x73\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetDrawableRenderOrders		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetDrawableOpacities			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x4f\x00\x70\x00\x61\x00\x63\x00\x69\x00\x74\x00\x69\x00\x65\x00\x73\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetDrawableOpacities		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetDrawableMaskCounts 			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x4d\x00\x61\x00\x73\x00\x6b\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x73\x00\x20\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetDrawableMaskCounts 		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetDrawableMasks				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x4d\x00\x61\x00\x73\x00\x6b\x00\x73\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetDrawableMasks			擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetDrawableVertexCounts		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x56\x00\x65\x00\x72\x00\x74\x00\x65\x00\x78\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x73\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetDrawableVertexCounts		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetDrawableVertexPositions		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x56\x00\x65\x00\x72\x00\x74\x00\x65\x00\x78\x00\x50\x00\x6f\x00\x73\x00\x69\x00\x74\x00\x69\x00\x6f\x00\x6e\x00\x73\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetDrawableVertexPositions	擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetDrawableVertexUvs			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x56\x00\x65\x00\x72\x00\x74\x00\x65\x00\x78\x00\x55\x00\x76\x00\x73\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetDrawableVertexUvs		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetDrawableIndexCounts			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x49\x00\x6e\x00\x64\x00\x65\x00\x78\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x73\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetDrawableIndexCounts		擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmGetDrawableIndices 			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x49\x00\x6e\x00\x64\x00\x69\x00\x63\x00\x65\x00\x73\x00\x20\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmGetDrawableIndices 			擾ł܂ł\n" @*/ ) ; return -1 ; }
			if( LIVE2DDLL.csmResetDrawableDynamicFlags		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x63\x00\x73\x00\x6d\x00\x52\x00\x65\x00\x73\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x44\x00\x79\x00\x6e\x00\x61\x00\x6d\x00\x69\x00\x63\x00\x46\x00\x6c\x00\x61\x00\x67\x00\x73\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API csmResetDrawableDynamicFlags	擾ł܂ł\n" @*/ ) ; return -1 ; }
		}
#else // _WIN64
		LIVE2DDLL.std_csmGetVersion						= ( DWORD					( __stdcall * )( void ) )																												GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetVersion"					) ;
		LIVE2DDLL.std_csmGetLatestMocVersion			= ( DWORD					( __stdcall * )( void ) )																												GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetLatestMocVersion"			) ;
		LIVE2DDLL.std_csmGetMocVersion					= ( DWORD					( __stdcall * )( const void* address, const DWORD size ) )																				GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetMocVersion"				) ;
		LIVE2DDLL.std_csmGetLogFunction					= ( csmLogFunctionP			( __stdcall * )( void ) )																												GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetLogFunction"				) ;
		LIVE2DDLL.std_csmSetLogFunction					= ( void					( __stdcall * )( csmLogFunctionP handler ) )																							GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmSetLogFunction"				) ;
		LIVE2DDLL.std_csmReviveMocInPlace				= ( void*					( __stdcall * )( void* address, const DWORD size ) )																					GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmReviveMocInPlace"				) ;
		LIVE2DDLL.std_csmGetSizeofModel					= ( DWORD 					( __stdcall * )( const void* moc ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetSizeofModel"				) ;
		LIVE2DDLL.std_csmInitializeModelInPlace			= ( void* 					( __stdcall * )( const void* moc, void* address, const DWORD size ) )																	GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmInitializeModelInPlace"		) ;
		LIVE2DDLL.std_csmUpdateModel					= ( void 					( __stdcall * )( void* model ) )																										GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmUpdateModel"					) ;
		LIVE2DDLL.std_csmReadCanvasInfo					= ( void 					( __stdcall * )( const void* model, D_CubismVector2* outSizeInPixels, D_CubismVector2* outOriginInPixels, float* outPixelsPerUnit ) )	GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmReadCanvasInfo"				) ;
		LIVE2DDLL.std_csmGetParameterCount				= ( int 					( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterCount"			) ;
		LIVE2DDLL.std_csmGetParameterIds 				= ( const char** 			( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterIds"				) ;
		LIVE2DDLL.std_csmGetParameterMinimumValues		= ( const float*			( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterMinimumValues"	) ;
		LIVE2DDLL.std_csmGetParameterMaximumValues		= ( const float*			( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterMaximumValues"	) ;
		LIVE2DDLL.std_csmGetParameterDefaultValues		= ( const float*			( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterDefaultValues"	) ;
		LIVE2DDLL.std_csmGetParameterValues				= ( float* 					( __stdcall * )( void* model ) )																										GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterValues"			) ;
		LIVE2DDLL.std_csmGetPartCount					= ( int 					( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetPartCount"					) ;
		LIVE2DDLL.std_csmGetPartIds						= ( const char**			( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetPartIds"					) ;
		LIVE2DDLL.std_csmGetPartOpacities				= ( float*					( __stdcall * )( void* model ) )																										GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetPartOpacities"				) ;
		LIVE2DDLL.std_csmGetPartParentPartIndices 		= ( const int*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetPartParentPartIndices"		) ;
		LIVE2DDLL.std_csmGetDrawableCount				= ( int 					( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableCount"				) ;
		LIVE2DDLL.std_csmGetDrawableIds					= ( const char**			( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableIds"				) ;
		LIVE2DDLL.std_csmGetDrawableConstantFlags 		= ( const BYTE*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableConstantFlags"		) ;
		LIVE2DDLL.std_csmGetDrawableDynamicFlags		= ( const BYTE*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableDynamicFlags"		) ;
		LIVE2DDLL.std_csmGetDrawableTextureIndices		= ( const int*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableTextureIndices"	) ;
		LIVE2DDLL.std_csmGetDrawableDrawOrders			= ( const int*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableDrawOrders"		) ;
		LIVE2DDLL.std_csmGetDrawableRenderOrders		= ( const int*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableRenderOrders"		) ;
		LIVE2DDLL.std_csmGetDrawableOpacities			= ( const float*			( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableOpacities"			) ;
		LIVE2DDLL.std_csmGetDrawableMaskCounts 			= ( const int*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableMaskCounts"		) ;
		LIVE2DDLL.std_csmGetDrawableMasks				= ( const int**				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableMasks"				) ;
		LIVE2DDLL.std_csmGetDrawableVertexCounts		= ( const int*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableVertexCounts"		) ;
		LIVE2DDLL.std_csmGetDrawableVertexPositions		= ( const D_CubismVector2**	( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableVertexPositions"	) ;
		LIVE2DDLL.std_csmGetDrawableVertexUvs			= ( const D_CubismVector2**	( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableVertexUvs"			) ;
		LIVE2DDLL.std_csmGetDrawableIndexCounts			= ( const int*				( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableIndexCounts"		) ;
		LIVE2DDLL.std_csmGetDrawableIndices 			= ( const unsigned short**	( __stdcall * )( const void* model ) )																									GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableIndices"			) ;
		LIVE2DDLL.std_csmResetDrawableDynamicFlags		= ( void					( __stdcall * )( void* model ) )																										GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmResetDrawableDynamicFlags"	) ;

		if( LIVE2DDLL.std_csmGetVersion						== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x56\x00\x65\x00\x72\x00\x73\x00\x69\x00\x6f\x00\x6e\x00\x40\x00\x30\x00\x09\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetVersion@0					擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetLatestMocVersion			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x4c\x00\x61\x00\x74\x00\x65\x00\x73\x00\x74\x00\x4d\x00\x6f\x00\x63\x00\x56\x00\x65\x00\x72\x00\x73\x00\x69\x00\x6f\x00\x6e\x00\x40\x00\x30\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetLatestMocVersion@0			擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetMocVersion					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x4d\x00\x6f\x00\x63\x00\x56\x00\x65\x00\x72\x00\x73\x00\x69\x00\x6f\x00\x6e\x00\x40\x00\x38\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetMocVersion@8				擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetLogFunction					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x4c\x00\x6f\x00\x67\x00\x46\x00\x75\x00\x6e\x00\x63\x00\x74\x00\x69\x00\x6f\x00\x6e\x00\x40\x00\x30\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetLogFunction@0				擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmSetLogFunction					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x53\x00\x65\x00\x74\x00\x4c\x00\x6f\x00\x67\x00\x46\x00\x75\x00\x6e\x00\x63\x00\x74\x00\x69\x00\x6f\x00\x6e\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmSetLogFunction@4				擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmReviveMocInPlace				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x52\x00\x65\x00\x76\x00\x69\x00\x76\x00\x65\x00\x4d\x00\x6f\x00\x63\x00\x49\x00\x6e\x00\x50\x00\x6c\x00\x61\x00\x63\x00\x65\x00\x40\x00\x38\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmReviveMocInPlace@8				擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetSizeofModel					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x6f\x00\x66\x00\x4d\x00\x6f\x00\x64\x00\x65\x00\x6c\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetSizeofModel@4				擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmInitializeModelInPlace			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x49\x00\x6e\x00\x69\x00\x74\x00\x69\x00\x61\x00\x6c\x00\x69\x00\x7a\x00\x65\x00\x4d\x00\x6f\x00\x64\x00\x65\x00\x6c\x00\x49\x00\x6e\x00\x50\x00\x6c\x00\x61\x00\x63\x00\x65\x00\x40\x00\x31\x00\x32\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmInitializeModelInPlace@12		擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmUpdateModel					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x55\x00\x70\x00\x64\x00\x61\x00\x74\x00\x65\x00\x4d\x00\x6f\x00\x64\x00\x65\x00\x6c\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmUpdateModel@4					擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmReadCanvasInfo					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x52\x00\x65\x00\x61\x00\x64\x00\x43\x00\x61\x00\x6e\x00\x76\x00\x61\x00\x73\x00\x49\x00\x6e\x00\x66\x00\x6f\x00\x40\x00\x31\x00\x36\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmReadCanvasInfo@16				擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetParameterCount				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetParameterCount@4			擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetParameterIds 				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x49\x00\x64\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetParameterIds@4				擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetParameterMinimumValues		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x4d\x00\x69\x00\x6e\x00\x69\x00\x6d\x00\x75\x00\x6d\x00\x56\x00\x61\x00\x6c\x00\x75\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetParameterMinimumValues@4	擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetParameterMaximumValues		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x4d\x00\x61\x00\x78\x00\x69\x00\x6d\x00\x75\x00\x6d\x00\x56\x00\x61\x00\x6c\x00\x75\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetParameterMaximumValues@4	擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetParameterDefaultValues		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x44\x00\x65\x00\x66\x00\x61\x00\x75\x00\x6c\x00\x74\x00\x56\x00\x61\x00\x6c\x00\x75\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetParameterDefaultValues@4	擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetParameterValues				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x61\x00\x6d\x00\x65\x00\x74\x00\x65\x00\x72\x00\x56\x00\x61\x00\x6c\x00\x75\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetParameterValues@4			擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetPartCount					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x74\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetPartCount@4					擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetPartIds						== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x74\x00\x49\x00\x64\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetPartIds@4					擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetPartOpacities				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x74\x00\x4f\x00\x70\x00\x61\x00\x63\x00\x69\x00\x74\x00\x69\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetPartOpacities@4				擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetPartParentPartIndices 		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x50\x00\x61\x00\x72\x00\x74\x00\x50\x00\x61\x00\x72\x00\x65\x00\x6e\x00\x74\x00\x50\x00\x61\x00\x72\x00\x74\x00\x49\x00\x6e\x00\x64\x00\x69\x00\x63\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetPartParentPartIndices@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetDrawableCount				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableCount@4				擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetDrawableIds					== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x49\x00\x64\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableIds@4				擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetDrawableConstantFlags 		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x43\x00\x6f\x00\x6e\x00\x73\x00\x74\x00\x61\x00\x6e\x00\x74\x00\x46\x00\x6c\x00\x61\x00\x67\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableConstantFlags@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetDrawableDynamicFlags		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x44\x00\x79\x00\x6e\x00\x61\x00\x6d\x00\x69\x00\x63\x00\x46\x00\x6c\x00\x61\x00\x67\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableDynamicFlags@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetDrawableTextureIndices		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x54\x00\x65\x00\x78\x00\x74\x00\x75\x00\x72\x00\x65\x00\x49\x00\x6e\x00\x64\x00\x69\x00\x63\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableTextureIndices@4	擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetDrawableDrawOrders			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x44\x00\x72\x00\x61\x00\x77\x00\x4f\x00\x72\x00\x64\x00\x65\x00\x72\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableDrawOrders@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetDrawableRenderOrders		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x52\x00\x65\x00\x6e\x00\x64\x00\x65\x00\x72\x00\x4f\x00\x72\x00\x64\x00\x65\x00\x72\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableRenderOrders@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetDrawableOpacities			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x4f\x00\x70\x00\x61\x00\x63\x00\x69\x00\x74\x00\x69\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableOpacities@4			擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetDrawableMaskCounts 			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x4d\x00\x61\x00\x73\x00\x6b\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableMaskCounts@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetDrawableMasks				== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x4d\x00\x61\x00\x73\x00\x6b\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableMasks@4				擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetDrawableVertexCounts		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x56\x00\x65\x00\x72\x00\x74\x00\x65\x00\x78\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableVertexCounts@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetDrawableVertexPositions		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x56\x00\x65\x00\x72\x00\x74\x00\x65\x00\x78\x00\x50\x00\x6f\x00\x73\x00\x69\x00\x74\x00\x69\x00\x6f\x00\x6e\x00\x73\x00\x40\x00\x34\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableVertexPositions@4	擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetDrawableVertexUvs			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x56\x00\x65\x00\x72\x00\x74\x00\x65\x00\x78\x00\x55\x00\x76\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableVertexUvs@4			擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetDrawableIndexCounts			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x49\x00\x6e\x00\x64\x00\x65\x00\x78\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableIndexCounts@4		擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmGetDrawableIndices 			== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x47\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x49\x00\x6e\x00\x64\x00\x69\x00\x63\x00\x65\x00\x73\x00\x40\x00\x34\x00\x09\x00\x09\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmGetDrawableIndices@4			擾ł܂ł\n" @*/ ) ; return -1 ; }
		if( LIVE2DDLL.std_csmResetDrawableDynamicFlags		== NULL ){ DXST_LOGFILE_ADDUTF16LE( "\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x4c\x00\x69\x00\x76\x00\x65\x00\x32\x00\x44\x00\x20\x00\x41\x00\x50\x00\x49\x00\x20\x00\x5f\x00\x63\x00\x73\x00\x6d\x00\x52\x00\x65\x00\x73\x00\x65\x00\x74\x00\x44\x00\x72\x00\x61\x00\x77\x00\x61\x00\x62\x00\x6c\x00\x65\x00\x44\x00\x79\x00\x6e\x00\x61\x00\x6d\x00\x69\x00\x63\x00\x46\x00\x6c\x00\x61\x00\x67\x00\x73\x00\x40\x00\x34\x00\x09\x00\x92\x30\xd6\x53\x97\x5f\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"Error : Live2D API _csmResetDrawableDynamicFlags@4	擾ł܂ł\n" @*/ ) ; return -1 ; }
#endif // _WIN64
	}

	// I
	return 0 ;
}

// Live2D Cubism 4 DLL ̉
static int Live2DCubism4_DLL_Unload( void )
{
	if( LIVE2DSYS.PF.Live2DCubismCoreDLL != NULL )
	{
		FreeLibrary( LIVE2DSYS.PF.Live2DCubismCoreDLL ) ;
		LIVE2DSYS.PF.Live2DCubismCoreDLL = NULL ;
	}

	LIVE2DDLL.csmGetVersion						= NULL ;
	LIVE2DDLL.csmGetLatestMocVersion			= NULL ;
	LIVE2DDLL.csmGetMocVersion					= NULL ;
	LIVE2DDLL.csmGetLogFunction					= NULL ;
	LIVE2DDLL.csmSetLogFunction					= NULL ;
	LIVE2DDLL.csmReviveMocInPlace				= NULL ;
	LIVE2DDLL.csmGetSizeofModel					= NULL ;
	LIVE2DDLL.csmInitializeModelInPlace			= NULL ;
	LIVE2DDLL.csmUpdateModel					= NULL ;
	LIVE2DDLL.csmReadCanvasInfo					= NULL ;
	LIVE2DDLL.csmGetParameterCount				= NULL ;
	LIVE2DDLL.csmGetParameterIds 				= NULL ;
	LIVE2DDLL.csmGetParameterMinimumValues		= NULL ;
	LIVE2DDLL.csmGetParameterMaximumValues		= NULL ;
	LIVE2DDLL.csmGetParameterDefaultValues		= NULL ;
	LIVE2DDLL.csmGetParameterValues				= NULL ;
	LIVE2DDLL.csmGetPartCount					= NULL ;
	LIVE2DDLL.csmGetPartIds						= NULL ;
	LIVE2DDLL.csmGetPartOpacities				= NULL ;
	LIVE2DDLL.csmGetPartParentPartIndices 		= NULL ;
	LIVE2DDLL.csmGetDrawableCount				= NULL ;
	LIVE2DDLL.csmGetDrawableIds					= NULL ;
	LIVE2DDLL.csmGetDrawableConstantFlags 		= NULL ;
	LIVE2DDLL.csmGetDrawableDynamicFlags		= NULL ;
	LIVE2DDLL.csmGetDrawableTextureIndices		= NULL ;
	LIVE2DDLL.csmGetDrawableDrawOrders			= NULL ;
	LIVE2DDLL.csmGetDrawableRenderOrders		= NULL ;
	LIVE2DDLL.csmGetDrawableOpacities			= NULL ;
	LIVE2DDLL.csmGetDrawableMaskCounts 			= NULL ;
	LIVE2DDLL.csmGetDrawableMasks				= NULL ;
	LIVE2DDLL.csmGetDrawableVertexCounts		= NULL ;
	LIVE2DDLL.csmGetDrawableVertexPositions		= NULL ;
	LIVE2DDLL.csmGetDrawableVertexUvs			= NULL ;
	LIVE2DDLL.csmGetDrawableIndexCounts			= NULL ;
	LIVE2DDLL.csmGetDrawableIndices 			= NULL ;
	LIVE2DDLL.csmResetDrawableDynamicFlags		= NULL ;

	// I
	return 0 ;
}

// ˑ֐

// Live2D Cubism4 ֘Ȁ֐̊ˑs֐
extern int Live2DCubism4_Initialize_PF( void )
{
	// DLL ̓ǂݍ
	if( Live2DCubism4_DLL_Load() < 0 )
	{
		return -1 ;
	}

	// RX^gobt@gpł邩ǂZbg
	LIVE2DSYS.EnableConstantBuffer = GRAWIN.Setting.UseGraphicsAPI == GRAPHICS_API_DIRECT3D11_WIN32 ? TRUE : FALSE ;

	// VF[_[IuWFNgt@Ccw`kf[^𓀂
	switch( GRAWIN.Setting.UseGraphicsAPI )
	{
#ifndef DX_NON_DIRECT3D11
	case GRAPHICS_API_DIRECT3D11_WIN32 :
		if( Live2DCubism4_SetupShaderCode( &DxShaderCodeBin_Live2D_Cubism4_D3D11Convert, DxShaderCodeBin_Live2D_Cubism4_D3D11 ) < 0 )
		{
			return -1 ;
		}
		break ;
#endif // DX_NON_DIRECT3D11

#ifndef DX_NON_DIRECT3D9
	case GRAPHICS_API_DIRECT3D9_WIN32 :
		if( Live2DCubism4_SetupShaderCode( &DxShaderCodeBin_Live2D_Cubism4_D3D9Convert, DxShaderCodeBin_Live2D_Cubism4_D3D9 ) < 0 )
		{
			return -1 ;
		}
		break ;
#endif // DX_NON_DIRECT3D9

	default :
		return -1 ;
	}

	return 0 ;
}

// Live2D Cubism4 ֘Ǎn֐̊ˑs֐
extern int Live2DCubism4_Terminate_PF( void )
{
	// DLL ̃A[h
	Live2DCubism4_DLL_Unload() ;

	return 0 ;
}

// Live2D Cubism4 ̃VF[_[쐬̊ˑs
extern int Live2DCubism4_GenerateShaders_PF( void )
{
	return 0 ;
}

// VF[_[̃ZbgAbvs
extern int Live2DCubism4_SetupShader_PF( int ConstantBufferHandle, D_CubismConstantBufferDxLib *ConstantBuffer, D_ShaderNames VertexShader, D_ShaderNames PixelShader )
{
	D_CubismShader_DxLib* shaderManager = D_CubismRenderer_DxLib::GetShaderManager();

	if( shaderManager == NULL )
	{
		return -1 ;
	}

	NS_SetUseVertexShader( shaderManager->GetVertexShader( VertexShader ) );
	NS_SetUsePixelShader( shaderManager->GetPixelShader( PixelShader ) );

	if( LIVE2DSYS.EnableConstantBuffer )
	{
		// Update 
		NS_UpdateShaderConstantBuffer( ConstantBufferHandle ) ;

		// Zbg 
		NS_SetShaderConstantBuffer( ConstantBufferHandle, DX_SHADERTYPE_VERTEX, 0 ) ;
		NS_SetShaderConstantBuffer( ConstantBufferHandle, DX_SHADERTYPE_PIXEL, 0 ) ;
	}
	else
	{
		NS_SetVSConstFMtx( 0, ConstantBuffer->projectMatrix ) ;
		NS_SetVSConstFMtx( 4, ConstantBuffer->clipMatrix ) ;
		NS_SetPSConstF( 8, *( ( FLOAT4 * )&ConstantBuffer->baseColor ) ) ;
		NS_SetPSConstF( 9, *( ( FLOAT4 * )&ConstantBuffer->channelFlag ) ) ;
	}

	return 0 ;
}

// Live2D Cubism4 ̕`̌ɌĂ΂ˑ֐
extern int Live2DCubism4_DrawAfter_PF( void )
{
	if( LIVE2DSYS.EnableConstantBuffer == FALSE )
	{
		NS_ResetVSConstF( 0, 8 ) ;
		NS_ResetPSConstF( 8, 2 ) ;
	}

	return 0 ;
}

bool D_CubismShader_DxLib::LoadShaderProgram(bool isPs, int assign, const char* entryPoint)
{
    bool bRet = false;
	char FilePath[ 1024 ];

    int vertexShader = -1;
    int pixelShader = -1;

    do
    {
		CL_strcpy( DX_CHARCODEFORMAT_ASCII, FilePath, entryPoint );
		if( isPs )
		{
			CL_strcat( DX_CHARCODEFORMAT_ASCII, FilePath, ".pso" ) ;
			pixelShader = Live2DCubism4_LoadShaderCode( FilePath, DX_SHADERTYPE_PIXEL ) ;
			if( pixelShader < 0 )
			{
				// CubismLogWarning("Fail Create Shader");
				break;
			}
            _shaderSetsPS[assign] = pixelShader;
		}
		else
		{
			CL_strcat( DX_CHARCODEFORMAT_ASCII, FilePath, ".vso" ) ;
			vertexShader = Live2DCubism4_LoadShaderCode( FilePath, DX_SHADERTYPE_VERTEX ) ;
			if( vertexShader < 0 )
			{
				// CubismLogWarning("Fail Create Shader");
				break;
			}
            _shaderSetsVS[assign] = vertexShader;
		}
        //  
        bRet = true;
    } while (0);

    return bRet;
}

// #ifndef DX_NON_NAMESPACE
// 
// }
// 
// #endif // DX_NON_NAMESPACE

#endif // DX_NON_LIVE2D_CUBISM4

